
function SFBItemsDisplay_CountItems()
	SFBItemsDisplay_CountBagItems();
	SFBItemsDisplay_CountBankBagItems();
	SFBItemsDisplay_ChooseFrame();
end
	
function SFBItemsDisplay_CountBagItems()
	
	SFBITEMS_VAR_FullCount = 0;
	SFBITEMS_VAR_EmptySlots = 0;
	
	if ( SFBITEMS_VAR_Enabled == false ) then
		return;
	end
	
	for cat = 1, table.getn(SFBItemsDisplay_CategoriesArray), 1 do
		for icnt = 1, table.getn(SFBItemsDisplay_CategoriesArray[cat].items), 1 do
			SFBItemsDisplay_CategoriesArray[cat].items[icnt].button = "";
			SFBItemsDisplay_CategoriesArray[cat].items[icnt].count = 0;
		end
	end
	-- Loop through bags.
	for bagID = 0, 4, 1 do
		local bText = getglobal(SFBITEMS_VAR_Bag[bagID]["text"]:GetName().."Text");
		local cnt = GetContainerNumSlots(bagID);
		SFBITEMS_VAR_Bag[bagID]["emptyslotscount"] = 0;
		local bagname = GetBagName(bagID);
		
		if ( cnt > 0 ) then

			-- Loop through slots.
			
			for slot = 1,cnt,1 do
				local link = GetContainerItemLink(bagID, slot);
				if ( link ) then
	  			
		  			local name = GetItemInfo(link);
		  			-- SFBItemsDisplay_Print(name);
		  			local tCat, tIndex;
					local cntitem,icnt = GetContainerItemInfo(bagID,slot);
					if ( name ) then
						if (icnt ) then
							SFBITEMS_VAR_FullCount = SFBITEMS_VAR_FullCount + icnt;
						end
						tCat, tIndex = SFBItemsDisplay_GetItem(name);
						
						if ( tCat ) then
							SFBItemsDisplay_CategoriesArray[tCat].items[tIndex].icon = cntitem;
							SFBItemsDisplay_CategoriesArray[tCat].items[tIndex].itemslot = slot;
							SFBItemsDisplay_CategoriesArray[tCat].items[tIndex].itembag = bagID;
							SFBItemsDisplay_CategoriesArray[tCat].items[tIndex].count = SFBItemsDisplay_CategoriesArray[tCat].items[tIndex].count + icnt;
			
						end
					end
					
				else
					if ( SFBItemsDisplay_CountBag(bagname) ) then -- Don't count empty slots for ammo or specialty bags
						SFBITEMS_VAR_Bag[bagID]["emptyslotscount"] = SFBITEMS_VAR_Bag[bagID]["emptyslotscount"] + 1;
						SFBITEMS_VAR_EmptySlots = SFBITEMS_VAR_EmptySlots + 1;
					end
				end
			end
		end
		SFBITEMS_VAR_Bag[bagID]["emptyslots"] = SFBITEMS_VAR_Bag[bagID]["emptyslotscount"];
	end
	
				
	
	if ( SFBITEMS_VAR_CanProcessCount == false ) then
		if ( SFBITEMS_VAR_FullCount ) then 
			if ( SFBITEMS_VAR_FullCount == SFBITEMS_VAR_LastCount ) then
				SFBITEMS_VAR_CanProcessCount = true;
			else
				SFBITEMS_VAR_LastCount = SFBITEMS_VAR_FullCount;
				return;
			end
		else
			return;
		end 
	end
	
		

end

function SFBItemsDisplay_CountBankBagItems()
	for cat = 1, table.getn(SFBItemsDisplay_CategoriesArray), 1 do
		for icnt = 1, table.getn(SFBItemsDisplay_CategoriesArray[cat].items), 1 do
			SFBItemsDisplay_CategoriesArray[cat].items[icnt].bankcount = SFBItemsDisplay_GetBankItemCount(SFBItemsDisplay_CategoriesArray[cat].items[icnt].name);
		end
	end
end

function SFBItemsDisplay_GetBankItemCount(name)
--	SFBItemsDisplay_Print("SFBItemsDisplay_GetBankItemCount "..name);

	if ( not name ) then return 0; end
	
	if ( not myProfile ) then	
		return;
	end
	
	local titembankcount = 0;
	-- Uses CharacterProfiler to store/count bank info
	if ( myProfile and myProfile[InventoryHawkVars.RealmName] and myProfile[InventoryHawkVars.RealmName]["Character"][InventoryHawkVars.PlayerName] ) then
		--SFBItemsDisplay_Print("Start counting "..name);
		local myBank = myProfile[InventoryHawkVars.RealmName]["Character"][InventoryHawkVars.PlayerName].Bank;
		if ( not myBank ) then return 0; end
	
		local bcnt, bbag;
		
		for bbag = 0, SFBITEMS_CONS_MAX_BANK_BAGS, 1 do
			local tBankBag = myBank["Bag"..bbag];
			if ( tBankBag and tBankBag.Contents ) then
				for bcnt = 1, 24, 1 do
					if ( tBankBag.Contents[bcnt] ) then
						if (tBankBag.Contents[bcnt].Name == name ) then
							local icnt = 1;
							if ( tBankBag.Contents[bcnt].Quantity ) then
								icnt = tBankBag.Contents[bcnt].Quantity;
							end
							titembankcount = titembankcount + icnt;
						end
					end
				
				end
			end
		end
		
		
	end
	--SFBItemsDisplay_Print("return "..titembankcount);
	return titembankcount;
end



function SFBItemsDisplay_CountBag(bagname)
	local ncntbag = nil;
	if ( not bagname ) then
		return false;
	end
	
	for i,v in pairs(SFBITEMS_BAG_AMMO_POUCH_NAMES) do
		if ( strfind(bagname,v) ) then
			return false;
		end
	end
	
	for i,v in pairs(SFBITEMS_SHARD_BAG_NAMES) do
		if ( strfind(bagname,v) ) then
			return false;
		end
	end	
		
	return true;
end






 
