

SFBItemsDisplay_ShowItems = 0;

function SFBItemsDisplay_DisplayList(forceShow)
	if ( SFBITEMS_VAR_ForceHideDisplay ) then
		return;
	end
	
	if (  SFBInventoryHawk_Player.hidelistonclick == 1 and SFBInventoryHawk_Player.hidelist == 1 
		or ( SFBInventoryHawk_Player.autohide == 1 and SFBITEMS_VAR_MouseEntered == false )
	) then
		SFBItemsDisplayListFrame:Hide();
		return;	
	else
		SFBItemsDisplayListFrame:Show();
	end
	
	if ( SFBInventoryHawk_Player.makeitemsbackground == 1 ) then
		SFBItemsDisplayJustShowFrame:Show();
		SFBItemsDisplayTextFrame:Hide();
	else
		SFBItemsDisplayTextFrame:Show();
		SFBItemsDisplayJustShowFrame:Hide();
	end
	
	if ( SFBInventoryHawk_Player.displayemptyslots == 1 ) then
		SFBItemsDisplay_SetupEmptySlotsText();
	else 
		IWEmptySlotsTextButton:Hide();
	end
	
	SFBItemsDisplay_SetupList(forceShow);
	SFBItemsDisplay_SetListDisplay(SFBItemsDisplay_ShowItems);
	
	
end

function SFBItemsDisplay_SetupEmptySlotsText()
	IWEmptySlotsTextButton:Show();
	if ( SFBITEMS_VAR_EmptySlots == 0 ) then
		IWEmptySlotsTextButtonText:SetTextColor(1.0,0.1,0.1);
		IWEmptySlotsTextButtonText:SetText(SFBITEMS_TEXT_INVENTORY_FULL);
		
	else
		IWEmptySlotsTextButtonText:SetTextColor(1.0,0.9,0.1);
		IWEmptySlotsTextButtonText:SetText(SFBITEMS_TEXT_EMPTY_SLOTS..": "..SFBITEMS_VAR_EmptySlots);
	end
	IWEmptySlotsTextButtonText:SetTextHeight(SFBInventoryHawk_Player.listfontsize);
	IWEmptySlotsTextButton:SetScale(2);
	IWEmptySlotsTextButton:SetScale(SFBITEMS_CONS_SETSCALE);
end

function SFBItemsDisplay_sortAlphabeticallyLowHigh(a,b)
	return a.name < b.name ;
end

--[[ 
function: SFBItemsDisplay_SetupList , optional forceShow 
	This function sets up the list but does not display it.
	forceShow is used to force the display of auto-hidden items.
]]
function SFBItemsDisplay_SetupList(forceShow)
	
	-- Display results

	SFBItemsDisplay_ShowItems = 0;
	
	
	for ltcnt = 1, SFBITEMS_CONS_MAXDISPLAY, 1 do 
		local htText = getglobal("SFBItemsDisplayJustShow"..ltcnt.."Text");
		local tButton = getglobal("SFBItemsDisplay"..ltcnt.."TextButton");
		htText:Hide();
		tButton:Hide();
	end
	
	-- Loop through Categories .. the first is always "none"
	for cat = 1,  table.getn(SFBItemsDisplay_CategoriesArray), 1 do

		-- if Max Display hit then stop
		if ( SFBItemsDisplay_ShowItems >= SFBITEMS_CONS_MAXDISPLAY ) then break; end
		local catShow = false;
		-- If category in set to "hide":then don't do anything
		if ( SFBItemsDisplay_CategoriesArray[cat].hide == 0 ) then
			

			-- if "hideemptycategory" we test to see if the category has any items that will be displayed.
			-- if not, we don't do anything.
			if ( SFBItemsDisplay_CategoriesArray[cat].hideemptycategory == 1 ) then

				-- run through all items in category until we find one we can display
				for cItem = 1,  table.getn(SFBItemsDisplay_CategoriesArray[cat].items), 1 do
					if ( SFBItemsDisplay_CanDisplayItem(SFBItemsDisplay_CategoriesArray[cat].items[cItem],forceShow ) ) then
						catShow = true;
						break;
					end
				end
			else
				catShow = true;
				
			end
			
			-- If we can display the category then go ahead else move on to next one
			if ( catShow ) then
				-- this creates the category button
				if ( cat > 1 ) then
					SFBItemsDisplay_DisplayCat(SFBItemsDisplay_CategoriesArray[cat]);
				end
				-- if Max Display hit then stop
				if ( SFBItemsDisplay_ShowItems >= SFBITEMS_CONS_MAXDISPLAY ) then break; end
				
				-- if the category is selected to be open then go ahead and check/display it's items.
				if ( SFBItemsDisplay_CategoriesArray[cat].open == 1 ) then

					-- if Alphabetize list is selected then first alphabetize the list
					if ( SFBInventoryHawk_Player.alphabetizelist == 1 ) then
						table.sort(SFBItemsDisplay_CategoriesArray[cat].items, SFBItemsDisplay_sortAlphabeticallyLowHigh);
					end
					-- now loop through and display what you can
					for cItem = 1,  table.getn(SFBItemsDisplay_CategoriesArray[cat].items), 1 do
						if ( SFBItemsDisplay_CanDisplayItem(SFBItemsDisplay_CategoriesArray[cat].items[cItem], forceShow ) )  then
							SFBItemsDisplay_CategoriesArray[cat].items[cItem].category = SFBItemsDisplay_CategoriesArray[cat].name;
							SFBItemsDisplay_DisplayCatItem(SFBItemsDisplay_CategoriesArray[cat].items[cItem]);
						end
					end
				end
			end
		end
	end


end


function SFBItemsDisplay_CanDisplayItem(item, forceShow) 
	if ( not item.goalcount ) then
		item.goalcount = item.count;
	end
		
	if ( item.hide == 1 ) then
		return false;
	elseif ( 
	 	( 
	 		( item.bankcount and item.bankcount > 0 and item.showifbank == 1 ) 
	 		or 
	 		( item.count == 0 and item.hidewhenempty == 0 ) 
	 		or 
	 		item.count > 0
 		) 
 		and
 		( 
	 		( item.goalcount < item.highlightnum and ( item.hidetilgoal == nil or item.hidetilgoal == 0 ) )
	 		or 
	 		( item.goalcount >=  item.highlightnum and item.hideongoalreached == 0)
 		)
 		and
 		(
 			( item.count < item.convamount and ( item.hidetilconv == nil or item.hidetilconv == 0 ) )
 			or
 			( item.count >= item.convamount )	
 		)
 		 
 	)
 	then
 		if (
 			( 
 				( item.autohide == 1 and SFBITEMS_VAR_MouseEntered == true ) 
 				or (item.autohide == 1 and forceShow ) 
 			)
			or item.autohide == 0 
			or SFBInventoryHawk_Player.peritemautohide == 0 
		) 
		then
			if ( SFBInventoryHawk_Player.titlebuttondisplay == "reagent" ) then
				local cat, item = SFBItemsDisplay_GetItem(item.name);
				if ( cat == 1 and item == 1 ) then
					return false;
				else
					return true;
				end
			else
				return true;
			end
 		else 
 			return false;
 		end
 	else
 		return false;
 	end
 	
 	
end

function SFBItemsDisplay_SetupButton(buttonId)
	local tText = getglobal("SFBItemsDisplay"..buttonId.."TextButtonText");
	local tTexture = getglobal("SFBItemsDisplay"..buttonId.."TextButtonTexture");
	local htText = getglobal("SFBItemsDisplayJustShow"..buttonId.."Text");
	local tButton = getglobal("SFBItemsDisplay"..buttonId.."TextButton");
	local tPrevCnt = buttonId - 1 ;
	tTexture:ClearAllPoints();
	tText:ClearAllPoints();
	tButton:ClearAllPoints();
	htText:ClearAllPoints();
	tButton:SetWidth(500);
	tText:SetWidth(500);
	htText:SetWidth(500);
	
	if ( SFBInventoryHawk_Player.alignment == "left" ) then
		if ( buttonId == 1 ) then
			tButton:SetPoint("TOPLEFT","SFBItemsDisplayTextFrame","TOPLEFT",0,0);
			htText:SetPoint("TOPLEFT","SFBItemsDisplayJustShowFrame","TOPLEFT",0,0);
		else
			tButton:SetPoint("TOPLEFT",getglobal("SFBItemsDisplay"..tPrevCnt.."TextButton"):GetName(),"BOTTOMLEFT",0,0);
			htText:SetPoint("TOPLEFT",getglobal("SFBItemsDisplayJustShow"..tPrevCnt.."Text"):GetName(),"BOTTOMLEFT",0,0);
		end
		tTexture:SetPoint("TOPLEFT",tButton:GetName(),"TOPLEFT",0,0);
		tText:SetPoint("LEFT",tTexture:GetName(),"RIGHT",0,0);
		tText:SetJustifyH("LEFT");
		htText:SetJustifyH("LEFT");
	else
		
		if ( buttonId == 1 ) then
			tButton:SetPoint("TOPRIGHT","SFBItemsDisplayTextFrame","TOPRIGHT",0,0);
			htText:SetPoint("TOPRIGHT","SFBItemsDisplayJustShowFrame","TOPRIGHT",0,0);
		else
			tButton:SetPoint("TOPRIGHT",getglobal("SFBItemsDisplay"..tPrevCnt.."TextButton"):GetName(),"BOTTOMRIGHT",0,0);
			htText:SetPoint("TOPRIGHT",getglobal("SFBItemsDisplayJustShow"..tPrevCnt.."Text"):GetName(),"BOTTOMRIGHT",0,0);
		end
		tTexture:SetPoint("TOPRIGHT",tButton:GetName(),"TOPRIGHT",0,0);
		tText:SetPoint("RIGHT",tTexture:GetName(),"LEFT",0,0);
		tText:SetJustifyH("RIGHT");
		htText:SetJustifyH("RIGHT");
	end
	
	tText:SetTextHeight(SFBInventoryHawk_Player.listfontsize);
	htText:SetTextHeight(SFBInventoryHawk_Player.listfontsize);
	
	tButton:SetHeight(SFBInventoryHawk_Player.listfontsize);
	htText:SetHeight(SFBInventoryHawk_Player.listfontsize);
	
	tTexture:SetHeight(SFBInventoryHawk_Player.listfontsize);
	tTexture:SetWidth(SFBInventoryHawk_Player.listfontsize);

	tButton:SetScale(2);
	tButton:SetScale(SFBITEMS_CONS_SETSCALE);
	SFBItemsDisplayTextFrame:SetScale(2);
	SFBItemsDisplayTextFrame:SetScale(SFBITEMS_CONS_SETSCALE);
	SFBItemsDisplayJustShowFrame:SetScale(2);
	SFBItemsDisplayJustShowFrame:SetScale(SFBITEMS_CONS_SETSCALE);
end

function SFBItemsDisplay_DisplayCat(cat, buttonId) 
	SFBItemsDisplay_ShowItems = SFBItemsDisplay_ShowItems + 1;
	if ( not buttonId ) then
		buttonId = SFBItemsDisplay_ShowItems;
	end
	SFBItemsDisplay_SetupButton(buttonId);
	local tColor = {};
	local tText = getglobal("SFBItemsDisplay"..buttonId.."TextButtonText");
	local tTexture = getglobal("SFBItemsDisplay"..buttonId.."TextButtonTexture");
	local htText = getglobal("SFBItemsDisplayJustShow"..buttonId.."Text");
	local tButton = getglobal("SFBItemsDisplay"..buttonId.."TextButton");
	if ( cat.open == 0 ) then
		tTexture:SetTexture("Interface\\AddOns\\InventoryHawk\\Plus.tga");
	else
		tTexture:SetTexture("Interface\\AddOns\\InventoryHawk\\Minus.tga");
	end
	tButton.itemType = "category";
	tButton.itemName = cat.name;
	tButton.itemCat = cat.name;
	tColor = SFBITEMS_VAR_Colors.category;
	tText:SetTextColor(tColor.r,tColor.g,tColor.b);
	htText:SetTextColor(tColor.r,tColor.g,tColor.b);
	tText:SetText(" -= "..cat.alias.." =-");
	htText:SetText("-= "..cat.alias.." =-");
	tButton:SetScale(2);
	tButton:SetScale(SFBITEMS_CONS_SETSCALE);
	local tWidth = tText:GetStringWidth();
	tButton:SetWidth(tWidth);
	tText:SetWidth(tWidth );
	htText:SetWidth(tWidth);
	tButton:Show();
	htText:Show();
	tButton:SetAlpha(SFBInventoryHawk_Player.listalpha);
	htText:SetAlpha(SFBInventoryHawk_Player.listalpha);
	
end

function SFBItemsDisplay_DisplayCatItem(item,buttonId)
	SFBItemsDisplay_ShowItems = SFBItemsDisplay_ShowItems + 1;
	if ( not buttonId ) then
		buttonId = SFBItemsDisplay_ShowItems;
	end
	SFBItemsDisplay_SetupButton(buttonId);
	local tColor = {};
	local tText = getglobal("SFBItemsDisplay"..buttonId.."TextButtonText");
	local tTexture = getglobal("SFBItemsDisplay"..buttonId.."TextButtonTexture");
	local htText = getglobal("SFBItemsDisplayJustShow"..buttonId.."Text");
	local tButton = getglobal("SFBItemsDisplay"..buttonId.."TextButton");
	local cat = SFBItemsDisplay_GetCategory(item.category);
	tButton.itemType = "reagent";
	tButton.itemName = item.name;
	tButton.itemCat = item.category;
	item.goalcount = 0;
	item.button = "";
	tButton:SetWidth(500);
	tText:SetWidth(500);
	htText:SetWidth(500);
	local newhighlightnum = 0;

	item.bankcount = item.bankcount or 0;
	local totalWBank = item.count + item.bankcount;
	local cattimes = tonumber(SFBItemsDisplay_CategoriesArray[cat].times);
	--if ( cattimes > 0 ) then
	item.goalcount = item.count;

	if ( cattimes ~= nil ) then
		if (item.highlightnum > 0 and cattimes > 0 ) then
			newhighlightnum = item.highlightnum * cattimes;
		else
			newhighlightnum = item.highlightnum;
		end
	else
		newhighlightnum = item.highlightnum;	
	end

	if (item.goalincludebank == 1 ) then
		item.goalcount = totalWBank;
	end
	
	local warnCnt = item.count;
	if ( item.warnincludebank == 1 ) then
		warnCnt = totalWBank;
	end
	
	if ( item.count >= item.convamount and item.convamount > 0 ) then
	
		local divid = math.floor(item.count / item.convamount);
		tText:SetText(item.alias..": "..item.count.." |cff00b2ff("..divid..")|r");
		htText:SetText(item.alias..": "..item.count.." |cff00b2ff("..divid..")|r");
	else
		
		tText:SetText(item.alias..": "..item.count);
		
		htText:SetText(item.alias..": "..item.count);
	end

	if ( item.bankcount > 0 and SFBInventoryHawk_Player.showbankcount == 1 ) then
		tText:SetText(tText:GetText().." |cff999999["..item.bankcount.."]|r");
		htText:SetText(htText:GetText().." |cff999999["..item.bankcount.."]|r");
	end	
	
	-- Added by Enitjus --
	if (SFBITEMS_VAR_ShowAltCounts) then
		if ( SFBInventoryHawk_AltItems ) then
			if (SFBInventoryHawk_AltItems[item.name] ~= nil) then
			    if (SFBInventoryHawk_AltItems[item.name].count > 0 and item.alt ~= 1) then
			        tText:SetText(tText:GetText().." |cffE278C3["..SFBInventoryHawk_AltItems[item.name].count.."]|r");
				htText:SetText(htText:GetText().." |cffE278C3["..SFBInventoryHawk_AltItems[item.name].count.."]|r");
			    end
			end
		end 
	end
	-- End Add --
	
				
	if (  item.alarm == 1 and warnCnt <=  item.minalarm ) then
		local msg;
		
		tColor = SFBITEMS_VAR_Colors.minwarning;
		if ( item.alterlowwarning == 0 ) then
			if not GetAddOnMetadata("BagSpace", "Version") then
				msg = "[Inventory Hawk]: " .. item.name .. " - is low!";
				DEFAULT_CHAT_FRAME:AddMessage(msg, 1.0, 0.0, 0.0);				
			else
				msg = "[Inventory Hawk]: " .. item.name .. " - is low!";
				BagSpace_Frame:AddMessage(msg, 1.0, 0.0, 0.0);
			end	
			item.alterlowwarning = 1;
		end
		
							
	elseif(  newhighlightnum > 0 and item.goalcount >=  newhighlightnum ) then
		if ( item.resetgoal == 1 ) then
			item.highlightnum = 0;
			tColor = SFBITEMS_VAR_Colors.normal;
		else
			tColor = SFBITEMS_VAR_Colors.highlight;
		end
		if ( item.alertgoal == 0 ) then
			if not GetAddOnMetadata("BagSpace", "Version") then
				msg = "[Inventory Hawk]: " .. item.name .. " - Goal Achived!";
				DEFAULT_CHAT_FRAME:AddMessage(msg, 0.0, 1.0, 0.0);				
			else
				msg = "[Inventory Hawk]: " .. item.name .. " - Goal Achived!";
				BagSpace_Frame:AddMessage(msg, 0.0, 1.0, 0.0);
			end	
			
			item.alertgoal = 1;
		end
		item.alterlowwarning = 0;
	else
		tColor = SFBITEMS_VAR_Colors.normal;
		item.alterlowwarning = 0;
		item.alertgoal = 0;
		
	end
				
				
	if ( newhighlightnum > 0 and item.goalcount < newhighlightnum ) then
		local toGoal = newhighlightnum - item.goalcount;
		tText:SetText(tText:GetText().." |cffff0000(".."-"..toGoal..")|r");
		htText:SetText(htText:GetText().." |cffff0000(".."-"..toGoal..")|r");
	--[[elseif ( item.highlightnum > 0 and item.goalcount > item.highlightnum ) then
		local toGoal =  item.goalcount - item.highlightnum;
		tText:SetText(tText:GetText().." |cff3fbf3f(".."+"..toGoal..")|r");
		htText:SetText(htText:GetText().." |cff3fbf3f(".."+"..toGoal..")|r");]]
	end
		
	tText:SetTextColor(tColor.r,tColor.g,tColor.b);
	htText:SetTextColor(tColor.r,tColor.g,tColor.b);	
			
	if ( not item.icon ) then
		item.icon = "";
	else
		if ( strlen(item.icon) > 0 ) then
			if ( SFBInventoryHawk_Player.hideicons == 1 ) then
				tTexture:SetTexture("");
				
			else
				tTexture:SetTexture(item.icon);
				
			end
		else
			tTexture:SetTexture("");
			
		end
	end
			
			
			
	tButton:SetScale(2);
	tButton:SetScale(SFBITEMS_CONS_SETSCALE);
	local tWidth = tText:GetStringWidth();
		
	tButton:SetWidth(tWidth);
	tText:SetWidth(tWidth );
	htText:SetWidth(tWidth);
				
	item.button = tButton:GetName();
	tButton:Show();
	htText:Show();
	tButton:SetAlpha(SFBInventoryHawk_Player.listalpha);
	htText:SetAlpha(SFBInventoryHawk_Player.listalpha);
end

--[[ 
function:  SFBItemsDisplay_SetListDisplay
	This is where we display the list we created with SFBItemsDisplay_SetupList.
	
]]
function SFBItemsDisplay_SetListDisplay(itemCnt)
	if ( SFBITEMS_VAR_Enabled == false ) then
		return;
	end
	if (  SFBInventoryHawk_Player.hidelistonclick == 1 and SFBInventoryHawk_Player.hidelist == 1 ) then
		return;
	end
	if ( not itemCnt or itemCnt == 0 ) then 
		itemCnt = SFBItemsDisplay_ShowItems;
	end
		
	local isNorm = SFBItemsDisplay_IsNormalDisplay();
	local tHeight = 0;
	SFBITEMS_VAR_GWidth = IWEmptySlotsTextButtonText:GetStringWidth() * 1.1;
	for i = itemCnt, 1, -1 do
		
		if ( SFBInventoryHawk_Player.makeitemsbackground == 0 ) then
			tFrame = getglobal("SFBItemsDisplay"..i.."TextButtonTexture");
			tText = getglobal("SFBItemsDisplay"..i.."TextButtonText");
			if ( tFrame:IsVisible() ) then
				tHeight = tHeight + tFrame:GetHeight();
				local tWidth = tText:GetStringWidth() + tText:GetHeight() + 4;
				if ( tWidth > SFBITEMS_VAR_GWidth ) then
					SFBITEMS_VAR_GWidth = tWidth
				end
				
			end
		else
			tFrame = getglobal("SFBItemsDisplayJustShow"..i.."Text");
		end 
		
	end
	
	tHeight = tHeight + 2;
	SFBItemsDisplayListFrame:SetWidth(SFBITEMS_VAR_GWidth);
	IWEmptySlotsTextButton:SetWidth(SFBITEMS_VAR_GWidth);
	IWEmptySlotsTextButtonText:SetWidth(SFBITEMS_VAR_GWidth);
	SFBItemsDisplayListFrame:SetBackdropColor(0, 0, 0, SFBInventoryHawk_Player.listbackgroundalpha);
	
	local byPoint = 0;
	if ( SFBInventoryHawk_Player.displayemptyslots == 1 ) then
		SFBItemsDisplayListFrame:SetHeight(tHeight + SFBInventoryHawk_Player.listfontsize);
		tyPoint = (SFBInventoryHawk_Player.listfontsize * -1) + SFBITEMS_VAR_ESNormSetPoint;
		byPoint = SFBInventoryHawk_Player.listfontsize + SFBITEMS_VAR_ESElseSetPoint;
	else
	 	SFBItemsDisplayListFrame:SetHeight(tHeight);
	 	tyPoint = SFBITEMS_VAR_ESNormSetPoint;
	 	byPoint = SFBITEMS_VAR_ESElseSetPoint;
	end
	
	
	if ( isNorm == true ) then
		IWEmptySlotsTextButton:ClearAllPoints();
		SFBItemsDisplayTextFrame:ClearAllPoints();
		SFBItemsDisplayJustShowFrame:ClearAllPoints();
		SFBItemsDisplayListFrame:ClearAllPoints();
		if ( SFBInventoryHawk_Player.alignment == "left" ) then
			IWEmptySlotsTextButton:SetPoint("TOPLEFT","SFBItemsDisplayListFrame","TOPLEFT",0,SFBITEMS_VAR_ESNormSetPoint);
			SFBItemsDisplayListFrame:SetPoint("TOPLEFT","SFBInventoryHawkButton","BOTTOMLEFT",0,SFBITEMS_VAR_ESNormSetPoint);
			IWEmptySlotsTextButtonText:SetJustifyH("LEFT");
			
		else
			IWEmptySlotsTextButton:SetPoint("TOPRIGHT","SFBItemsDisplayListFrame","TOPRIGHT",0,SFBITEMS_VAR_ESNormSetPoint);
			SFBItemsDisplayListFrame:SetPoint("TOPRIGHT","SFBInventoryHawkButton","BOTTOMRIGHT",0,SFBITEMS_VAR_ESNormSetPoint);
			IWEmptySlotsTextButtonText:SetJustifyH("RIGHT");
		end


		SFBItemsDisplayTextFrame:SetPoint("TOPLEFT","SFBItemsDisplayListFrame","TOPLEFT",0,tyPoint );
		SFBItemsDisplayTextFrame:SetPoint("TOPRIGHT","SFBItemsDisplayListFrame","TOPRIGHT",0, tyPoint);
			
		SFBItemsDisplayJustShowFrame:SetPoint("TOPLEFT","SFBItemsDisplayListFrame","TOPLEFT",0, tyPoint);
		SFBItemsDisplayJustShowFrame:SetPoint("TOPRIGHT","SFBItemsDisplayListFrame","TOPRIGHT",0, tyPoint);
			
		
		
	else
		
		SFBItemsDisplayListFrame:ClearAllPoints();
		IWEmptySlotsTextButton:ClearAllPoints();
		SFBItemsDisplayJustShowFrame:ClearAllPoints();
		SFBItemsDisplayListFrame:ClearAllPoints();
		if ( SFBInventoryHawk_Player.alignment == "left" ) then
			IWEmptySlotsTextButton:SetPoint("BOTTOMLEFT","SFBItemsDisplayListFrame","BOTTOMLEFT",0,SFBITEMS_VAR_ESElseSetPoint);
			SFBItemsDisplayListFrame:SetPoint("BOTTOMLEFT","SFBInventoryHawkButton","TOPLEFT",0,SFBITEMS_VAR_ESElseSetPoint);
			IWEmptySlotsTextButtonText:SetJustifyH("LEFT");
			
		else
			IWEmptySlotsTextButton:SetPoint("BOTTOMRIGHT","SFBItemsDisplayListFrame","BOTTOMRIGHT",0,SFBITEMS_VAR_ESElseSetPoint);
			SFBItemsDisplayListFrame:SetPoint("BOTTOMRIGHT","SFBInventoryHawkButton","TOPRIGHT",0,SFBITEMS_VAR_ESElseSetPoint);
			IWEmptySlotsTextButtonText:SetJustifyH("RIGHT");
		end
		
		SFBItemsDisplayTextFrame:SetPoint("BOTTOMLEFT","SFBItemsDisplayListFrame","BOTTOMLEFT",0,byPoint );
		SFBItemsDisplayTextFrame:SetPoint("BOTTOMRIGHT","SFBItemsDisplayListFrame","BOTTOMRIGHT",0, byPoint);
			
		SFBItemsDisplayJustShowFrame:SetPoint("BOTTOMLEFT","SFBItemsDisplayListFrame","BOTTOMLEFT",0, byPoint);
		SFBItemsDisplayJustShowFrame:SetPoint("BOTTOMRIGHT","SFBItemsDisplayListFrame","BOTTOMRIGHT",0, byPoint);
		
	end
	
	
	
end

function SFBItemsDisplay_SetupBags()

	SFBITEMS_VAR_Bag[0].text:Show();
	SFBITEMS_VAR_Bag[1].text:Show();
	SFBITEMS_VAR_Bag[2].text:Show();
	SFBITEMS_VAR_Bag[3].text:Show();
	SFBITEMS_VAR_Bag[4].text:Show();
	SFBITEMS_VAR_Bag[0].bar:Show();
	SFBITEMS_VAR_Bag[1].bar:Show();
	SFBITEMS_VAR_Bag[2].bar:Show();
	SFBITEMS_VAR_Bag[3].bar:Show();
	SFBITEMS_VAR_Bag[4].bar:Show();
	SFBITEMS_VAR_Bag[0].text:SetAlpha(0);
	SFBITEMS_VAR_Bag[1].text:SetAlpha(0);
	SFBITEMS_VAR_Bag[2].text:SetAlpha(0);
	SFBITEMS_VAR_Bag[3].text:SetAlpha(0);
	SFBITEMS_VAR_Bag[4].text:SetAlpha(0);
	SFBITEMS_VAR_Bag[0].bar:SetAlpha(0);
	SFBITEMS_VAR_Bag[1].bar:SetAlpha(0);
	SFBITEMS_VAR_Bag[2].bar:SetAlpha(0);
	SFBITEMS_VAR_Bag[3].bar:SetAlpha(0);
	SFBITEMS_VAR_Bag[4].bar:SetAlpha(0);
	
	if ( SFBInventoryHawk_Player.bags_showbagtext == 1 or SFBInventoryHawk_Player.bags_showbagbars == 1 ) then
		for bagID = 0, 4, 1 do
		
			local bText = getglobal(SFBITEMS_VAR_Bag[bagID].text:GetName().."Text");
			local cnt = GetContainerNumSlots(bagID);
				
			SFBITEMS_VAR_Bag[bagID].bar:SetMinMaxValues(0,cnt);				
			local bagname = GetBagName(bagID);
			local ncntbag = nil;
	
			if ( bagname ) then
				ncntbag = strfind(bagname,"Ammo");
			end
			if ( not ncntbag and bagname ) then
				ncntbag = strfind(bagname,"Quiver");
			end
			if ( not ncntbag and bagname ) then
				ncntbag = strfind(bagname,"Soul");
			end
			if ( ncntbag ) then
				cnt = 0;
			end
					
			if ( cnt > 0 ) then
				if ( SFBInventoryHawk_Player.bags_showbagbars == 1 ) then
					SFBITEMS_VAR_Bag[bagID].bar:SetAlpha(1);
				end
				if ( SFBInventoryHawk_Player.bags_showbagtext == 1 ) then
					SFBITEMS_VAR_Bag[bagID].text:SetAlpha(1);
				end
				
				if ( SFBITEMS_VAR_Bag[bagID].emptyslots ~= 0 ) then
					local bval = 0;
					
					if( SFBInventoryHawk_Player.bags_reversebagbars == 1 ) then
						bval = cnt - SFBITEMS_VAR_Bag[bagID].emptyslots;
					else
						bval = SFBITEMS_VAR_Bag[bagID].emptyslots;
					end
					
					if ( bval == nil ) then
						SFBItemsDisplay_CountBagItems()
						if( SFBInventoryHawk_Player.bags_reversebagbars == 1 ) then
							bval = cnt - SFBITEMS_VAR_Bag[bagID].emptyslots;
						else
							bval = SFBITEMS_VAR_Bag[bagID].emptyslots;
						end
					end 
					
	
					SFBITEMS_VAR_Bag[bagID].bar:SetValue(bval);
					
					if ( SFBInventoryHawk_Player.bags_showbagbartext == 1 ) then
						getglobal(SFBITEMS_VAR_Bag[bagID].bar:GetName().."Label"):SetText(bval);
					else
						
						getglobal(SFBITEMS_VAR_Bag[bagID].bar:GetName().."Label"):SetText("");
					end
					
					if ( SFBITEMS_VAR_Bag[bagID].emptyslots == cnt) then
						bText:SetTextColor(SFBITEMS_VAR_BagColors.empty.r,SFBITEMS_VAR_BagColors.empty.g,SFBITEMS_VAR_BagColors.empty.b);
						SFBITEMS_VAR_Bag[bagID].bar:SetStatusBarColor(SFBITEMS_VAR_BagColors.empty.r,SFBITEMS_VAR_BagColors.empty.g,SFBITEMS_VAR_BagColors.empty.b,talpha);
		
					elseif ( SFBITEMS_VAR_Bag[bagID].emptyslots >= 10 ) then
						SFBITEMS_VAR_Bag[bagID].bar:SetStatusBarColor(SFBITEMS_VAR_BagColors.high.r,SFBITEMS_VAR_BagColors.high.g,SFBITEMS_VAR_BagColors.high.b,talpha);
						bText:SetTextColor(SFBITEMS_VAR_BagColors.high.r,SFBITEMS_VAR_BagColors.high.g,SFBITEMS_VAR_BagColors.high.b);
					elseif ( SFBITEMS_VAR_Bag[bagID].emptyslots >= 5 ) then
						SFBITEMS_VAR_Bag[bagID].bar:SetStatusBarColor(SFBITEMS_VAR_BagColors.medium.r,SFBITEMS_VAR_BagColors.medium.g,SFBITEMS_VAR_BagColors.medium.b,talpha);
						bText:SetTextColor(SFBITEMS_VAR_BagColors.medium.r,SFBITEMS_VAR_BagColors.medium.g,SFBITEMS_VAR_BagColors.medium.b);
					else
						SFBITEMS_VAR_Bag[bagID].bar:SetStatusBarColor(SFBITEMS_VAR_BagColors.low.r,SFBITEMS_VAR_BagColors.low.g,SFBITEMS_VAR_BagColors.low.b,talpha);	
						bText:SetTextColor(SFBITEMS_VAR_BagColors.low.r,SFBITEMS_VAR_BagColors.low.g,SFBITEMS_VAR_BagColors.low.b);	
					end
					bText:SetText(SFBITEMS_VAR_Bag[bagID].emptyslots);
					
				else 
					
					bText:SetText("");
					if( SFBInventoryHawk_Player.bags_reversebagbars == 1 ) then
						SFBITEMS_VAR_Bag[bagID].bar:SetValue(cnt);
						getglobal(SFBITEMS_VAR_Bag[bagID].bar:GetName().."Label"):SetText(cnt);
						SFBITEMS_VAR_Bag[bagID].bar:SetStatusBarColor(SFBITEMS_VAR_BagColors.full.r,SFBITEMS_VAR_BagColors.full.g,SFBITEMS_VAR_BagColors.full.b,talpha);				
					else
						getglobal(SFBITEMS_VAR_Bag[bagID].bar:GetName().."Label"):SetText("0");
						SFBITEMS_VAR_Bag[bagID].bar:SetValue(0);
					end
					if ( SFBInventoryHawk_Player.bags_showbagbartext == 0 ) then
						getglobal(SFBITEMS_VAR_Bag[bagID].bar:GetName().."Label"):SetText("");
					end
		
					
				end
			end	
		end
	else
		SFBITEMS_VAR_Bag[0].text:Hide();
		SFBITEMS_VAR_Bag[1].text:Hide();
		SFBITEMS_VAR_Bag[2].text:Hide();
		SFBITEMS_VAR_Bag[3].text:Hide();
		SFBITEMS_VAR_Bag[4].text:Hide();
		SFBITEMS_VAR_Bag[0].bar:Hide();
		SFBITEMS_VAR_Bag[1].bar:Hide();
		SFBITEMS_VAR_Bag[2].bar:Hide();
		SFBITEMS_VAR_Bag[3].bar:Hide();
		SFBITEMS_VAR_Bag[4].bar:Hide();
	end
end

function SFBItemsDisplay_SetupEmptySlots()
	IWEmptySlotsTextButton:Hide();
	if ( SFBInventoryHawk_Player.displayemptyslots == 1) then
		IWEmptySlotsTextButton:Show();
		IWEmptySlotsTextButtonText:SetTextHeight(SFBInventoryHawk_Player.listfontsize);
		IWEmptySlotsTextButton:SetWidth(IWEmptySlotsTextButtonText:GetStringWidth() * 1.1);
		IWEmptySlotsTextButtonText:SetWidth(IWEmptySlotsTextButtonText:GetStringWidth() * 1.1);
		IWEmptySlotsTextButton:SetScale(2);
		IWEmptySlotsTextButton:SetScale(SFBITEMS_CONS_SETSCALE);
		
		-- For Empty slots count
		if ( SFBITEMS_VAR_EmptySlots == 0 ) then
			IWEmptySlotsTextButtonText:SetTextColor(1.0,0.1,0.1);
			IWEmptySlotsTextButtonText:SetText(SFBITEMS_TEXT_INVENTORY_FULL);
		else
			IWEmptySlotsTextButtonText:SetTextColor(1.0,0.9,0.1);
			IWEmptySlotsTextButtonText:SetText(SFBITEMS_TEXT_EMPTY_SLOTS..": "..SFBITEMS_VAR_EmptySlots);
		end
	end
end